DevExtreme React - Component Configuration Syntax

To help you configure DevExtreme UI components in a React-style code structure, we implemented configuration components. These are elements nested in JSX code as if they represented a UI component's sub-elements, but from the technical point of view, they only carry the configuration data. This means that UI component properties can be supplied declaratively and selectively, with default fallbacks in place.

Static Property Value

Function component
Class component
import Button from 'devextreme-react/button';

export default function App() {
    return (
        <Button
            disabled={false}
            width={50}
            text="Click me"
        />
    );
}
import Button from 'devextreme-react/button';

class App extends React.Component {
    render() {
        return (
            <Button
                disabled={false}
                width={50}
                text="Click me"
            />
        );
    }
}

Properties of the Object Type

Use nested configuration components. In the following example, we configure the Chart UI component's tooltip property:

Function component
Class component
import Chart, {
    Tooltip
} from 'devextreme-react/chart';

export default function App() {
    return (
        <Chart>
            <Tooltip
                enabled={true}
                format="thousands"
            />
        </Chart>
    );
}
import Chart, {
    Tooltip
} from 'devextreme-react/chart';

class App extends React.Component {
    render() {
        return (
            <Chart>
                <Tooltip
                    enabled={true}
                    format="thousands"
                />
            </Chart>
        );
    }
}

Object type properties that depend on other properties' values are not implemented as nested configuration components because they cannot be typed (columns[].editorOptions in the DataGrid, item's editorOptions in the Form, items[].options in the Toolbar). These properties should be specified with an object.

Function component
Class component
import DataGrid, {
    Column
} from 'devextreme-react/data-grid';

const columnEditorOptions = { width: 100 };

export default function App() {
    return (
        <DataGrid>
            <Column
                editorOptions={columnEditorOptions}
            />
        </DataGrid>
    );
}
import DataGrid, {
    Column
} from 'devextreme-react/data-grid';

class App extends React.Component {
    columnEditorOptions = { width: 100 };

    render() {
        return (
            <DataGrid>
                <Column
                    editorOptions={this.columnEditorOptions}
                />
            </DataGrid>
        );
    }
}
IMPORTANT
We recommend that you declare the object outside the configuration component to prevent possible issues caused by unnecessary re-rendering.

If you use React Hooks and need to define a configuration object inside a function component, wrap this object in the useMemo hook to preserve the object's reference between state changes:

App.js
import React, { useState, useMemo } from 'react';
import Form, { Label, SimpleItem } from 'devextreme-react/form';

const data = { isAddressRequired: false, Address: '' };

export default function App() {
    const [visible, setVisible] = useState(false);
    const checkBoxOptions = useMemo(() => {
        return {
            text: "Display Address",
            onValueChanged: (e) => {
                setVisible(e.value);
            }
        }
    }, []);
    const addressOptions = useMemo(() => {
        return {
            placeholder: 'Enter your addresss',
            maxLength: 50
        }
    }, []);

    return (
        <Form formData={data}
            width={400}>
            <SimpleItem
                dataField="isAddressRequired"
                editorType="dxCheckBox"
                editorOptions={checkBoxOptions}>
                <Label visible={false} />
            </SimpleItem>
            <SimpleItem
                dataField="Address"
                editorType="dxTextBox"
                editorOptions={addressOptions}
                visible={visible}
            />
        </Form>
    );
}

Collections

Use nested configuration components. The following example shows how to configure the DataGrid's columns property:

Function component
Class component
import DataGrid, {
    Column
} from 'devextreme-react/data-grid';

export default function App() {
    return (
        <DataGrid>
            <Column
                dataField="firstName"
                caption="First Name"
            />
            <Column
                dataField="lastName"
                caption="Last Name"
                defaultVisible={true}
            />
        </DataGrid>
    );
}
import DataGrid, {
    Column
} from 'devextreme-react/data-grid'; 

class App extends React.Component {
    render() {
        return (
            <DataGrid>
                <Column
                    dataField="firstName"
                    caption="First Name"
                />
                <Column
                    dataField="lastName"
                    caption="Last Name"
                    defaultVisible={true}
                />
            </DataGrid>
        );
    }
}

DevExtreme collection UI components also support the Item element. It allows you to declare collection items in the UI component markup. An Item element can contain custom markup and have properties that control parts of item appearance, such as badge in the following code. The properties are described in the items section of each collection UI component.

Function component
Class component
import List, {
    Item
} from 'devextreme-react/list';

export default function App() {
    return (
        <List>
            <Item>Orange</Item>
            <Item badge="New">White</Item>
            <Item>Black</Item>
        </List>
    );
}
import List, {
    Item
} from 'devextreme-react/list';

class App extends React.Component {
    render() {
        return (
            <List>
                <Item>Orange</Item>
                <Item badge="New">White</Item>
                <Item>Black</Item>
            </List>
        );
    }
}

Event Handling

Function component
Class component
import { useCallback } from 'react';
import Button from 'devextreme-react/button';

export default function App() {
    const handleButtonClick = useCallback((e) => {
        alert("The button was clicked")
    }, []);

    return (
        <Button
            onClick={handleButtonClick}
        />
    );
}
import Button from 'devextreme-react/button';

class App extends React.Component {
    constructor(props) {
        super(props);
        // Uncomment the line below to bind the handler to the React component's context, for example, to call this.setState()
        // this.handleButtonClick = this.handleButtonClick.bind(this);
    }

    render() {
        return (
            <Button
                onClick={this.handleButtonClick}
            />
        );
    }

    handleButtonClick(e) {
        alert("The button was clicked")
    }
}
IMPORTANT
In function components, wrap the event handler declaration into the useCallback React Hook to prevent possible issues caused by unnecessary re-rendering.

Callback Functions

Function component
Class component
import { useCallback } from 'react';
import VectorMap, { Layer } from 'devextreme-react/vector-map';

export default function App() {
    const customizeLayers = useCallback((elements) => {
        // ...
    }, []);

    return (
        <VectorMap>
            <Layer
                customize={customizeLayers}
            />
        </VectorMap>
    );
}
import VectorMap, { Layer } from 'devextreme-react/vector-map';

class App extends React.Component {
    render() {
        return (
            <VectorMap>
                <Layer
                    customize={this.customizeLayers}
                />
            </VectorMap>
        );
    }

    customizeLayers(elements) {
        // ...
    }
}
IMPORTANT
In function components, wrap the callback function declaration into the useCallback React Hook to prevent possible issues caused by unnecessary re-rendering.

In class components, callback functions are executed outside the React component's context. If the context is important, explicitly bind the callback function to it in the constructor.

Class component
class App extends React.Component {
    myCountry: string = 'USA'; // we need to access this context variable in the callback function

    constructor(props) {
        super(props);
        this.customizeLayers = this.customizeLayers.bind(this);
    }

    customizeLayers(elements) {
        let country = this.myCountry;
        // ...
    }
    // ...        
}

Declare Content in the Markup

The following UI components allow you to declare their content directly in the markup:

The following is an example with ScrollView:

Function component
Class component
import ScrollView from 'devextreme-react/scroll-view';

export default function App() {
    return (
        <ScrollView>
            <div>Some scrollable content</div>
        </ScrollView>
    );
}
import ScrollView from 'devextreme-react/scroll-view';

class App extends React.Component {
    render() {
        return (
            <ScrollView>
                <div>Some scrollable content</div>
            </ScrollView>
        );
    }
}
IMPORTANT

These UI components do not support dynamically or conditionally rendered content in their root element. For example, the following code does not work:

App.js
<Drawer ... >
    {
        someCondition && <div> ... </div>
        // when the condition changes in runtime, the UI component may not render content correctly
    }
</Drawer>

Wrap the content in a static element:

App.js
<Drawer ... >
    <div>
        {
            someCondition && <div> ... </div>
        }
    </div>
</Drawer>

Note that React.Fragment is a dynamically rendered element and doesn't fit in this case. Use static elements such as div or span instead.

Markup Customization

You can display custom content in DevExtreme components. We supply two types of properties for this task: those that end with 'Render' (for example, cellRender), and those that end with 'Component' (for example, cellComponent).

'Render' properties allow you to employ rendering functions. A DevExpress control calls the specified function and renders the return value to the virtual DOM. Note that a rendering function is not a component: it lacks state and cannot utilize hooks. However, you can create a rendering function inside your component and enclose it within the useCallback hook. You can pass local variables as dependencies and use them in your template. The following article contains an example: Using a Rendering Function.

'Component' properties use React components to specify templates. A DevExpress control renders those templates to the virtual DOM. Since a template is a component, it can have its internal state and use hooks inside (which is not possible with rendering functions). The following article contains an example: Using a Custom Component.

In some cases, you need to use the 'Template' properties instead. Refer to the following article for more information: Using the Template Component.

Using a Rendering Function

The following example customizes a DataGrid component to display a combination of grid data and a TextBox value within cells. The code wraps a rendering function within a useCallback hook. This way you can pass the TextBox value to the column's cellRender property.

NOTE
You can also define a rendering function outside of a component if you don't need to pass any dependencies to the 'Render' property.
Function component
Class component
import React, { useState, useCallback } from 'react';
import TextBox from 'devextreme-react/text-box';
import DataGrid, { Column } from 'devextreme-react/data-grid';

const dataSource = [1, 2, 3, 4, 5];

function App() {
    const [value, setValue] = useState('.');

    const onTextBoxValueChange = (e) => {
        setValue(e);
    };

    const cell = useCallback((cell) => <div>{cell.data + value}</div>, [value]);

    return (
        <>
            <TextBox value={value} onValueChange={onTextBoxValueChange} />
            <DataGrid dataSource={dataSource}>
                <Column caption="Low" cellRender={cell} />
            </DataGrid>
        </>
    );
}

export default App;
import * as React from 'react';
import TextBox from 'devextreme-react/text-box';
import DataGrid, { Column } from 'devextreme-react/data-grid';

const dataSource = [1, 2, 3, 4, 5];

class App extends React.Component {
    constructor() {
        super();

        this.renderCell = this.renderCell.bind(this);
        this.onTextBoxValueChange = this.onTextBoxValueChange.bind(this);

        this.state = { value: '.' };
    }

    onTextBoxValueChange(e) {
        this.setState({ value: e });
    };

    renderCell(cell) {
        return <div>{cell.data + this.state.value}</div>;
    }

    render() {
        return (
            <>
                <TextBox value={this.state.value} onValueChange={this.onTextBoxValueChange} />
                <DataGrid dataSource={dataSource}>
                    <Column caption="Low" cellRender={this.renderCell} />
                </DataGrid>
            </>
        );
    }
}

export default App;

Using a Custom Component

You can define custom content in a separate component if you need to utilize the state or hooks.

NOTE
For Class components, we recommend that you use React.PureComponent instead of React.Component (the latter can be re-rendered unnecessarily). Alternatively, you can implement a shouldComponentUpdate() method.

In the following code snippet, a standalone ListItem component is created to render List items. This component specifies the itemComponent property value. If necessary, you can reuse this ListItem component in another List.

Function component
Class component
import React, { useCallback, useState } from "react";
import List from "devextreme-react/list";

import "devextreme/dist/css/dx.light.css";

const dataSource = ["Apples", "Bananas", "Cranberries"];
const defaultWeight = 1;

const ListItem = ({ data }) => {
    const [weight, setWeight] = useState(defaultWeight);
    const onWeightChange = useCallback(
        (e) => setWeight(e.target.value || defaultWeight),
        []
    );

    return (
        <div
            style={{
                display: "flex",
                flexDirection: "row",
                justifyContent: "space-between",
                alignItems: "center",
            }}
        >
            <span>{`${data}, ${weight} lb`}</span>
            <input type="number" placeholder="Weight" onChange={onWeightChange} />
        </div>
    );
};

function App() {
    return (
        <div style={{ maxWidth: 400 }}>
            <List
                activeStateEnabled={false}
                items={dataSource}
                itemComponent={ListItem}
            />
        </div>
    );
}

export default App;
import * as React from 'react';
import List from 'devextreme-react/list';

import 'devextreme/dist/css/dx.light.css';

const dataSource = ['Apples', 'Bananas', 'Cranberries'];
const defaultWeight = 1;

class ListItem extends React.PureComponent {
    constructor() {
        super();

        this.onWeightChange = this.onWeightChange.bind(this);
        this.state = { weight: defaultWeight };
    }

    onWeightChange(e) {
        this.setState({ weight: e.target.value || defaultWeight });
    }

    render() {
        return (
            <div style={{
                display: 'flex',
                flexDirection: 'row',
                justifyContent: 'space-between',
                alignItems: 'center',
            }}>
                <span>{`${this.props.data}, ${this.state.weight} lb`}</span>
                <input
                    type='number'
                    placeholder='Weight'
                    onChange={this.onWeightChange}
                />
            </div>
        );
    }
}

class App extends React.Component {
    render() {
        return (
            <div style={{ maxWidth: 400 }}>
                <List activeStateEnabled={false} items={dataSource} itemComponent={ListItem} />
            </div>
        );
    }
}

export default App;

Using the Template Component

Several properties are not implemented as nested configuration components (columns[].editorOptions in the DataGrid, item's editorOptions in the Form, items[].options in the Toolbar). These properties do not have a Render or Component property where you would pass your rendering function or custom component. However, you can still use the Template element to customize the markup.

The Template element declares a named template. Its name property value should be assigned to a Template property of the UI component. You can specify the template's markup as follows:

  • Rendering function
    Pass the rendering function to the Template's render property:

    Function component
    Class component
    data.js
    import React, { useCallback, useState } from 'react';
    import Form, { Item } from 'devextreme-react/form';
    import { Template } from 'devextreme-react/core/template';
    import service from './data.js';
    import { CheckBox } from 'devextreme-react/check-box';
    
    const employee = service.getEmployee();
    const positions = service.getPositions();
    const positionEditorOptions = {
        items: positions,
        value: '',
        itemTemplate: 'selectBoxItem'
    };
    
    export default function App() {
        const [upperCasePositions, setUpperCasePositions] = useState(false);
        const renderSelectBoxItem = useCallback((item) => {
            return <div>{upperCasePositions ? item.toUpperCase() : item}</div>;
        }, [upperCasePositions]);
        const onUpperCaseSettingChange = useCallback((e) => {
            setUpperCasePositions(e.value);
        }, []);
        return (
            <>
                <CheckBox
                    text="Display positions in upper case"
                    onValueChanged={onUpperCaseSettingChange}
                />
                <Form formData={employee}>
                    <Item
                        dataField="Position"
                        editorType="dxSelectBox"
                        editorOptions={positionEditorOptions}
                    />
                    <Template name="selectBoxItem" render={renderSelectBoxItem} />
                </Form>
            </>
        );
    }
    import * as React from 'react';
    import Form, { Item } from 'devextreme-react/form';
    import { Template } from 'devextreme-react/core/template';
    import { CheckBox } from 'devextreme-react/check-box';
    import service from './data.js';
    
    class App extends React.Component {
        constructor(props) {
            super(props);
            this.state = { upperCasePositions: false };
            this.employee = service.getEmployee();
            this.positions = service.getPositions();
            this.renderSelectBoxItem = this.renderSelectBoxItem.bind(this);
            this.onUpperCaseSettingChange = this.onUpperCaseSettingChange.bind(this);
            this.positionEditorOptions = {
                items: this.positions,
                value: '',
                itemTemplate: 'selectBoxItem'
            };
        }
        renderSelectBoxItem(item) {
            return <div>{this.state.upperCasePositions ? item.toUpperCase() : item}</div>;
        }
        onUpperCaseSettingChange(e) {
            this.setState({ upperCasePositions: e.value });
        }
        render() {
            return (
                <>
                <CheckBox
                    text="Display positions in upper case"
                    onValueChanged={this.onUpperCaseSettingChange}
                />
                <Form formData={this.employee}>
                    <Item
                        dataField="Position"
                        editorType="dxSelectBox"
                        editorOptions={this.positionEditorOptions}
                    />
                    <Template name="selectBoxItem" render={this.renderSelectBoxItem} />
                </Form>
            </>
            );
        }
    }
    
    export default App;
    const employee = {
        ID: 1,
        FirstName: 'John',
        LastName: 'Heart',
        Position: 'CEO',
        BirthDate: '1964/03/16',
        HireDate: '1995/01/15',
        Address: '351 S Hill St., Los Angeles, CA',
        Phone: '360-684-1334',
        Email: 'jheart@dx-email.com'
    };
    
    const positions = [
        'HR Manager',
        'IT Manager',
        'CEO',
        'Controller',
        'Sales Manager',
        'Support Manager',
        'Shipping Manager'
    ];
    
    export default {
        getEmployee() {
            return employee;
        },
        getPositions() {
            return positions;
        }
    }
  • Custom component
    Assign the custom component to the Template's component property:

    Function component
    Class component
    data.js
    import React, { useState, useCallback } from 'react';
    import Form, { Item } from 'devextreme-react/form';
    import { Template } from 'devextreme-react/core/template';
    import { Switch } from 'devextreme-react/switch';
    import { RadioGroup } from 'devextreme-react/radio-group';
    import service from './data.js';
    
    const employee = service.getEmployee();
    const positions = service.getPositions();
    
    function RadioGroupItemTemplate({ data }) {
        const [lineThrough, setLineThrough] = useState(false);
        const onLineThroughChange = useCallback((e) => {
            setLineThrough(e);
        }, []);
        return (
            <div style={{
                display: 'flex',
                flexDirection: 'row',
                justifyContent: 'space-between',
                alignItems: 'center',
            }}>
                <Switch onValueChange={onLineThroughChange}/>
                <div style={{
                    marginLeft: '10px',
                    textDecoration: lineThrough ? 'line-through' : 'none',
                }}>{data}</div>
            </div>
        );
    };
    
    function App() {
        const [positionEditorOptions] = useState({
            items: positions,
            value: '',
            itemTemplate: 'radioGroupItem',
        });
        return (
            <div style={{ maxWidth: 400 }}>
                <Form formData={employee}>
                    <Item
                        dataField="Position"
                        editorType="dxRadioGroup"
                        editorOptions={positionEditorOptions}
                    />
                    <Template name="radioGroupItem" component={RadioGroupItemTemplate} />
                </Form>
            </div>
        );
    };
    
    export default App;
    import * as React from 'react';
    import Form, { Item } from 'devextreme-react/form';
    import { Template } from 'devextreme-react/core/template';
    import { Switch } from 'devextreme-react/switch';
    import { RadioGroup } from 'devextreme-react/radio-group';
    import service from './data.js';
    
    class RadioGroupItemTemplate extends React.PureComponent {
        constructor() {
            super();
            this.state = { lineThrough: false };
            this.onLineThroughChange = this.onLineThroughChange.bind(this);
        }
        onLineThroughChange(e) {
            this.setState({ lineThrough: e });
        }
        render() {
            return (
                <div style={{
                    display: 'flex',
                    flexDirection: 'row',
                    justifyContent: 'space-between',
                    alignItems: 'center',
                }}>
                    <Switch onValueChange={this.onLineThroughChange}/>
                    <div style={{
                        marginLeft: '10px',
                        textDecoration: this.state.lineThrough ? 'line-through' : 'none',
                    }}>
                        {this.props.data}
                    </div>
                </div>
            );
        }
    }
    
    class App extends React.Component {
        constructor(props) {
            super(props);
            this.employee = service.getEmployee();
            this.positions = service.getPositions();
            this.positionEditorOptions = {
                items: this.positions,
                value: '',
                itemTemplate: 'radioGroupItem'
            };
        }
        render() {
            return (
                <div style={{ maxWidth: 400 }}>
                    <Form formData={this.employee}>
                        <Item
                            dataField="Position"
                            editorType="dxRadioGroup"
                            editorOptions={this.positionEditorOptions}
                        />
                        <Template name="radioGroupItem" component={RadioGroupItemTemplate} />
                    </Form>
                </div>
            );
        }
    }
    
    export default App;
    const employee = {
        ID: 1,
        FirstName: 'John',
        LastName: 'Heart',
        Position: 'CEO',
        BirthDate: '1964/03/16',
        HireDate: '1995/01/15',
        Address: '351 S Hill St., Los Angeles, CA',
        Phone: '360-684-1334',
        Email: 'jheart@dx-email.com'
    };
    
    const positions = [
        'HR Manager',
        'IT Manager',
        'CEO',
        'Controller',
        'Sales Manager',
        'Support Manager',
        'Shipping Manager'
    ];
    
    export default {
        getEmployee() {
            return employee;
        },
        getPositions() {
            return positions;
        }
    }

Call Methods

To call UI component methods, you need the UI component instance. Create a ref and attach it to the target component via the ref property. In the following code, this approach is used to get a TextBox instance:

Function component
Class component
import React, { useRef, useCallback } from 'react';
import Button from 'devextreme-react/button';
import TextBox from 'devextreme-react/text-box';

export default function App() {
    const textBox = useRef(null);
    const focusTextBox = useCallback(() => {
        // `current.instance()` points to the UI component instance 
        textBox.current.instance().focus();
    }, []);

    return (
        <div>
            <TextBox ref={textBox} />
            <Button text="Focus TextBox" onClick={focusTextBox} />
        </div>
    );
}
import Button from 'devextreme-react/button';
import TextBox from 'devextreme-react/text-box';

class App extends React.Component {
    constructor(props) {
        super(props);

        this.textBoxRef = React.createRef();

        this.focusTextBox = () => {
            this.textBox.focus()
        };
    }

    get textBox() {
        // `current.instance()` points to the UI component instance
        return this.textBoxRef.current.instance();
    }

    render() {
        return (
            <div>
                <TextBox ref={this.textBoxRef} />
                <Button text="Focus TextBox" onClick={this.focusTextBox} />
            </div>
        );
    }
}

Alternatively, you can assign the UI component instance to a variable and use it to call the methods. This approach is not compatible with React Hooks.

Class component
import Button from 'devextreme-react/button';
import TextBox from 'devextreme-react/text-box';

class App extends React.Component {
    constructor(props) {
        super(props);

        this.saveTextBoxInstance = this.saveTextBoxInstance.bind(this);
        this.focusTextBox = this.focusTextBox.bind(this);
    }

    saveTextBoxInstance(e) {
        this.textBoxInstance = e.component;
    }

    focusTextBox() {
        this.textBoxInstance.focus();
    }

    render() {
        return (
            <div>
                <TextBox onInitialized={this.saveTextBoxInstance} />
                <Button text="Focus TextBox" onClick={this.focusTextBox} />
            </div>
        );
    }
}

Get a UI Component Instance

For information on this matter, refer to Call Methods.

Data Layer

DevExtreme Data Layer is a set of components for working with data. The following example shows how to use the DataSource component with the List UI component:

Function component
Class component
import React, { useEffect } from 'react';
import DataSource from 'devextreme/data/data_source';
import List from 'devextreme-react/list';

const items = [
    { text: '123' },
    { text: '234' },
    { text: '567' }
];
const dataSource = new DataSource({
    store: {
        type: "array",
        data: items
    },
    sort: { getter: "text", desc: true }
});

export default function App() {
    useEffect(() => {
        // A DataSource instance created outside a UI component should be disposed of manually.
        return () => { dataSource.dispose(); }
    });
    return (
        <List dataSource={dataSource} />
    ); 
}
import DataSource from 'devextreme/data/data_source';
import List from 'devextreme-react/list';

const items = [
    { text: '123' },
    { text: '234' },
    { text: '567' }
];

class Example extends React.Component {
    constructor(props) {
        super(props);

        this.dataSource = new DataSource({
            store: {
                type: 'array',
                data: items
            },
            sort: { getter: 'text', desc: true }
        });
    }

    render() {
        return (
            <List dataSource={this.dataSource} />
        );
    }

    componentWillUnmount() {
        // A DataSource instance created outside a UI component should be disposed of manually.
        this.dataSource.dispose();
    }
}
NOTE
When a data layer component's properties are modified, the bound UI component is not re-rendered.

DevExtreme Validation Features

In the following example, two textboxes are placed in a validation group that is validated on a button click. Each textbox has a set of validation rules. The validation result is displayed under the textboxes in a validation summary.

Function component
Class component
import React, { useState, useCallback } from 'react';
import TextBox from 'devextreme-react/text-box';
import Validator, { RequiredRule, EmailRule } from 'devextreme-react/validator';
import ValidationGroup from 'devextreme-react/validation-group';
import Button from 'devextreme-react/button';

export default function App() {
    const [email, setEmail] = useState(null);
    const [password, setPassword] = useState(null);
    const validate = useCallback((params) => {
        const result = params.validationGroup.validate();
        if (result.isValid) {
            // The values are valid
            // Submit them...
            // ...
            // ... and then reset
            // params.validationGroup.reset();
        }
    }, []);
    const handleEmailChange = useCallback((e) => {
        setEmail(e.value);
    }, []);
    const handlePasswordChange = useCallback((e) => {
        setPassword(e.value);
    }, []);

    return (
        <ValidationGroup>
            <TextBox value={email} onValueChanged={handleEmailChange}>
                <Validator>
                    <RequiredRule message="Email is required" />
                    <EmailRule message="Email is invalid" />
                </Validator>
            </TextBox>

            <TextBox value={password} mode="password" onValueChanged={handlePasswordChange}>
                <Validator>
                    <RequiredRule message="Password is required" />
                </Validator>
            </TextBox>
            <Button onClick={validate} text="Submit" />
        </ValidationGroup>
    ); 
}
import TextBox from 'devextreme-react/text-box';
import Validator, { RequiredRule, EmailRule } from 'devextreme-react/validator';
import ValidationGroup from 'devextreme-react/validation-group';
import Button from 'devextreme-react/button';

class App extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            email: null,
            password: null
        };
        this.handleEmailChange = (e) => {
            this.setState({
                email: e.value
            });
        };
        this.handlePasswordChange = (e) => {
            this.setState({
                password: e.value
            });
        };
        this.validate = this.validate.bind(this);
    }

    render() {
        return (
            <ValidationGroup>
                <TextBox value={this.state.email} onValueChanged={this.handleEmailChange}>
                    <Validator>
                        <RequiredRule message="Email is required" />
                        <EmailRule message="Email is invalid" />
                    </Validator>
                </TextBox>

                <TextBox value={this.state.password} mode="password" onValueChanged={this.handlePasswordChange}>
                    <Validator>
                        <RequiredRule message="Password is required" />
                    </Validator>
                </TextBox>
                <Button onClick={this.validate} text="Submit" />
            </ValidationGroup>
        );
    }

    validate(params) {
        const result = params.validationGroup.validate();
        if (result.isValid) {
            // The values are valid
            // Submit them...
            // ...
            // ... and then reset
            // params.validationGroup.reset();
        }
    }
}

Refer to the Data Validation article for more information.

DevExtreme Vue - Component Configuration Syntax

Static String Property Value

HTML
<DxButton text="Simple button" />

Static Non-String Property Value

HTML
<DxButton
    :disabled="false"
    :width="50"
/>

Properties of the Object Type

Use nested configuration components. In the following example, we configure the Chart's tooltip property:

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxChart>
        <DxTooltip
            :enabled="true"
            format="thousands"
        />
    </DxChart>
</template>

<script>
import DxChart, {
    DxTooltip
} from 'devextreme-vue/chart';

export default {
    components: {
        DxChart,
        DxTooltip
    }
}
</script>
<template>
    <DxChart>
        <DxTooltip
            :enabled="true"
            format="thousands"
        />
    </DxChart>
</template>

<script setup>
import DxChart, {
    DxTooltip
} from 'devextreme-vue/chart';
</script>

Object type properties that depend on other properties' values are not implemented as nested configuration components because they cannot be typed (columns[].editorOptions in the DataGrid, item's editorOptions in the Form, items[].options in the Toolbar). These properties should be specified with an object.

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxDataGrid>
        <DxColumn
            :editor-options="columnEditorOptions"
        />
    </DxDataGrid>
</template>

<script>
import DxDataGrid, {
    DxColumn
} from 'devextreme-vue/data-grid';

export default {
    components: {
        DxDataGrid,
        DxColumn
    },
    data() {
        return {
            columnEditorOptions: { width: 100 }
        }
    }
}
</script>
<template>
    <DxDataGrid>
        <DxColumn
            :editor-options="columnEditorOptions"
        />
    </DxDataGrid>
</template>

<script setup>
import DxDataGrid, {
    DxColumn
} from 'devextreme-vue/data-grid';

const columnEditorOptions = { width: 100 };
</script>
IMPORTANT
We recommend that you declare the object outside the configuration component to prevent possible issues caused by unnecessary re-rendering.

Collections

Use nested configuration components. The following example shows how to configure the DataGrid's columns property:

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxDataGrid>
        <DxColumn
            data-field="firstName"
            caption="Name"
        />
        <DxColumn
            data-field="lastName"
            caption="Surname"
        />
    </DxDataGrid>
</template>

<script>
import DxDataGrid, {
    DxColumn
} from 'devextreme-vue/data-grid';

export default {
    components: {
        DxDataGrid,
        DxColumn
    }
}
</script>
<template>
    <DxDataGrid>
        <DxColumn
            data-field="firstName"
            caption="Name"
        />
        <DxColumn
            data-field="lastName"
            caption="Surname"
        />
    </DxDataGrid>
</template>

<script setup>
import DxDataGrid, {
    DxColumn
} from 'devextreme-vue/data-grid';
</script>

DevExtreme collection UI components also support the DxItem element. It allows you to declare collection items in the UI component markup. DxItem can contain custom markup and have attributes that control parts of item appearance, such as badge in the following code. The attributes are described in the items section of each collection UI component. Ensure to specify that an item's content is in the default slot.

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxList>
        <DxItem>
            <template #default>
                Orange
            </template>
        </DxItem>
        <DxItem badge="New">
            <template #default>
                White
            </template>
        </DxItem>
        <DxItem>
            <template #default>
                Black
            </template>
        </DxItem>
    </DxList>
</template>

<script>
import DxList, {
    DxItem
} from 'devextreme-vue/list';

export default {
    components: {
        DxList,
        DxItem
    }
}
</script>
<template>
    <DxList>
        <DxItem>
            <template #default>
                Orange
            </template>
        </DxItem>
        <DxItem badge="New">
            <template #default>
                White
            </template>
        </DxItem>
        <DxItem>
            <template #default>
                Black
            </template>
        </DxItem>
    </DxList>
</template>

<script setup>
import DxList, {
    DxItem
} from 'devextreme-vue/list';
</script>

DxItem also supports structural directives provided by Vue, such as v-for:

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxList>
        <DxItem>
            <template #default>
                <h1>Available items</h1>
            </template>
        </DxItem>
        <DxItem
            v-for="item in listItems"
            :key="item.text"
            :badge="item.badge">
            <template #default>
                {{ item.text }}
            </template>
        </DxItem>
    </DxList>
</template>

<script>
import DxList, {
    DxItem
} from 'devextreme-vue/list';

export default {
    components: {
        DxList,
        DxItem
    },
    data() {
        return {
            listItems: [{
                text: 'Cars',
                badge: '12'
            }, {
                text: 'Bikes',
                badge: '5'
            }]
        }
    }
}
</script>
<template>
    <DxList>
        <DxItem>
            <template #default>
                <h1>Available items</h1>
            </template>
        </DxItem>
        <DxItem
            v-for="item in listItems"
            :key="item.text"
            :badge="item.badge">
            <template #default>
                {{ item.text }}
            </template>
        </DxItem>
    </DxList>
</template>

<script setup>
import DxList, {
    DxItem
} from 'devextreme-vue/list';

const listItems = [{
    text: 'Cars',
    badge: '12'
}, {
    text: 'Bikes',
    badge: '5'
}];
</script>

Event Handling

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxButton
        text="OK"
        @click="okClicked"
    />
</template>

<script>
import DxButton from 'devextreme-vue/button';
import notify from 'devextreme/ui/notify';

export default {
    components: {
        DxButton
    },
    methods: {
        okClicked: function(e) {
            notify('The OK button was clicked')
        }
    }
}
</script>
<template>
    <DxButton
        text="OK"
        @click="okClicked"
    />
</template>

<script setup>
import DxButton from 'devextreme-vue/button';
import notify from 'devextreme/ui/notify';

const okClicked = (e) => {
    notify('The OK button was clicked')
}
</script>

Callback Functions

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxVectorMap>
        <DxLayer :customize="customizeLayers" />
    </DxVectorMap>
</template>

<script>
import DxVectorMap, {
    DxLayer
} from 'devextreme-vue/vector-map';

export default {
    components: {
        DxVectorMap,
        DxLayer
    },
    methods: {
        customizeLayers(elements) {
            // ...
        }
    }
}
</script>
<template>
    <DxVectorMap>
        <DxLayer :customize="customizeLayers" />
    </DxVectorMap>
</template>

<script setup>
import DxVectorMap, {
    DxLayer
} from 'devextreme-vue/vector-map';

const customizeLayers = (elements) => {
    // ...
}
</script>

One-Way Property Binding

Changes in the bindingProperty are propagated to the TextBox's value, but not vice versa:

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxTextBox :value="bindingProperty" />
</template>

<script>
import DxTextBox from 'devextreme-vue/text-box';

export default {
    components: {
        DxTextBox
    },
    data() {
        return {
            bindingProperty: 'Some value'
        }
    }
}
</script>
<template>
    <DxTextBox :value="bindingProperty" />
</template>

<script setup>
import { ref } from "vue";
import DxTextBox from 'devextreme-vue/text-box';

let bindingProperty = ref('Some value');
</script>

Two-Way Property Binding

Changes in the bindingProperty are propagated to the TextBox's value and vice versa:

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxTextBox v-model:value="bindingProperty" />
</template>

<script>
import DxTextBox from 'devextreme-vue/text-box';

export default {
    components: {
        DxTextBox
    },
    data() {
        return {
            bindingProperty: 'Some value'
        }
    }
}
</script>
<template>
    <DxTextBox v-model:value="bindingProperty" />
</template>

<script setup>
import { ref } from "vue";
import DxTextBox from 'devextreme-vue/text-box';

let bindingProperty = ref('Some value');
</script>
IMPORTANT
In Vue 2 applications, use the .sync modifier to implement two-way binding.

Declare Content in the Markup

The following UI components allow you to declare their content directly in the markup:

The following is an example with ScrollView:

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxScrollView>
        <div>Some scrollable content</div>
    </DxScrollView>
</template>

<script>
import DxScrollView from 'devextreme-vue/scroll-view';

export default {
    components: {
        DxScrollView
    }
}
</script>
<template>
    <DxScrollView>
        <div>Some scrollable content</div>
    </DxScrollView>
</template>

<script setup>
import DxScrollView from 'devextreme-vue/scroll-view';
</script>
IMPORTANT

These UI components do not support dynamically or conditionally rendered content in their root element. For example, the following code does not work:

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxDrawer ... >
        <router-view></router-view>
    </DxDrawer>
</template>

<script>
    //...
</script>
<template>
    <DxDrawer ... >
        <router-view></router-view>
    </DxDrawer>
</template>

<script setup>
    //...
</script>

Wrap the content in a static element:

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxDrawer ... >
        <div>
            <router-view></router-view>
        </div>
    </DxDrawer>
</template>

<script>
    //...
</script>
<template>
    <DxDrawer ... >
        <div>
            <router-view></router-view>
        </div>
    </DxDrawer>
</template>

<script setup>
    //...
</script>

Templates

Templates allow you to customize UI components. DevExtreme templates make use of the named slots functionality provided by Vue.

In the following code, an itemTemplate called list-item and a groupTemplate called list-group customize items and groups in the List UI component. The data slot prop exposes the item or group data object; the index slot prop gives access to the item index.

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxList
        :items="groupedItems"
        :grouped="true"
        item-template="list-item"
        group-template="list-group">
        <template #list-item="{ data, index }">
            {{ index }} - {{ data.itemProperty }}
        </template>
        <template #list-group="{ data }">
            {{ data.groupProperty }}
        </template>
    </DxList>
</template>

<script>
import DxList from 'devextreme-vue/list';

export default {
    components: {
        DxList
    },
    data() {
        return {
            groupedItems: [ /* ... */ ]
        }
    }
}
</script>
<template>
    <DxList
        :items="groupedItems"
        :grouped="true"
        item-template="list-item"
        group-template="list-group">
        <template #list-item="{ data, index }">
            {{ index }} - {{ data.itemProperty }}
        </template>
        <template #list-group="{ data }">
            {{ data.groupProperty }}
        </template>
    </DxList>
</template>

<script setup>
import DxList from 'devextreme-vue/list';

const groupedItems = [ /* ... */ ];
</script>
IMPORTANT
In Vue 2 applications, a <template> should not contain more than one root element. Vue 3 applications have no restriction.

Refer to the common Custom Templates article for more information.

Call Methods

To call UI component methods, you need the UI component instance. Define its key in the ref attribute. Then, pass the key to the $refs property to get the component. The UI component instance is stored in the component's instance field:

App.vue (Options API)
App.vue (Composition API)
<template>
    <div>
        <DxTextBox :ref="textBoxRefKey" />
        <DxButton text="Focus TextBox" @click="focusTextBox" />
    </div>
</template>

<script>
import DxButton from 'devextreme-vue/button';
import DxTextBox from 'devextreme-vue/text-box';

const textBoxRefKey = "my-text-box";

export default {
    components: {
        DxTextBox,
        DxButton
    },
    data: function() {
        return {
            textBoxRefKey
        };
    },
    methods: {
        focusTextBox: function() {
            this.textBox.focus();
        }
    },
    computed: {
        textBox: function() {
            return this.$refs[textBoxRefKey].instance;
        }
    }
};
</script>
<template>
    <div>
        <DxTextBox ref="textBoxRef" />
        <DxButton text="Focus TextBox" @click="focusTextBox" />
    </div>
</template>

<script setup>
import DxButton from 'devextreme-vue/button';
import DxTextBox from 'devextreme-vue/text-box';

import { ref } from 'vue';

const textBoxRef = ref(null);
const focusTextBox = () => {  
    textBoxRef.value.instance.focus();
};
</script>

Alternatively, you can assign the UI component instance to a variable and use it to call the methods:

App.vue (Options API)
App.vue (Composition API)
<template>
    <div>
        <DxDataGrid ...
            @initialized="saveGridInstance">
        </DxDataGrid>
        <DxButton text="Refresh data" @click="refresh"/>
    </div>
</template>

<script>
import DxDataGrid from 'devextreme-vue/data-grid';
import DxButton from 'devextreme-vue/button';

export default {
    components: {
        DxDataGrid,
        DxButton
    },
    data: function() {
        return {
            dataGridInstance: null
        };
    },
    methods: {
        saveGridInstance: function(e) {
            this.dataGridInstance = e.component;
        },
        refresh: function() {
            this.dataGridInstance.refresh();
        }
    }
};
</script>
<template>
    <div>
        <DxDataGrid ...
            @initialized="saveGridInstance">
        </DxDataGrid>
        <DxButton text="Refresh data" @click="refresh"/>
    </div>
</template>

<script setup>
import DxDataGrid from 'devextreme-vue/data-grid';
import DxButton from 'devextreme-vue/button';

let dataGridInstance = null;

const saveGridInstance = (e) => {
    dataGridInstance = e.component;
}

const refresh = () => {
    dataGridInstance.refresh();
}
</script>

Get a UI Component Instance

For information on this matter, refer to Call Methods.

Data Layer

DevExtreme Data Layer is a set of components for working with data. Refer to the Data Layer API reference for code examples.

DevExtreme Validation Features

In the following example, two textboxes are placed in a validation group that is validated on a button click. Each textbox has a set of validation rules. The validation result is displayed under the textboxes in a validation summary.

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxValidationGroup>
        <DxTextBox v-model:value="email">
            <DxValidator>
                <DxRequiredRule message="Email is required" />
                <DxEmailRule message="Email is invalid" />
            </DxValidator>
        </DxTextBox>

        <DxTextBox v-model:value="password" mode="password">
            <DxValidator>
                <DxRequiredRule message="Password is required" />
            </DxValidator>
        </DxTextBox>

        <DxValidationSummary />

        <DxButton @click="validate" text="Submit" />
    </DxValidationGroup>
</template>

<script>
import DxTextBox from 'devextreme-vue/text-box';
import DxValidator, {
    DxRequiredRule,
    DxEmailRule
} from 'devextreme-vue/validator';
import DxValidationGroup from 'devextreme-vue/validation-group';
import DxValidationSummary from 'devextreme-vue/validation-summary';
import DxButton from 'devextreme-vue/button';

export default {
    components: {
        DxTextBox,
        DxValidator,
        DxRequiredRule,
        DxEmailRule,
        DxValidationGroup,
        DxValidationSummary,
        DxButton
    },
    data() {
        return {
            email: undefined,
            password: undefined
        }
    },
    methods: {
        validate(params) {
            let result = params.validationGroup.validate();
            if (result.isValid) {
                // the values are valid
                // submit and reset them
                // params.validationGroup.reset();
                console.log(result);
            }
        }
    }
}
</script>
<template>
    <DxValidationGroup>
        <DxTextBox v-model:value="email">
            <DxValidator>
                <DxRequiredRule message="Email is required" />
                <DxEmailRule message="Email is invalid" />
            </DxValidator>
        </DxTextBox>

        <DxTextBox v-model:value="password" mode="password">
            <DxValidator>
                <DxRequiredRule message="Password is required" />
            </DxValidator>
        </DxTextBox>

        <DxValidationSummary />

        <DxButton @click="validate" text="Submit" />
    </DxValidationGroup>
</template>

<script setup>
import DxTextBox from 'devextreme-vue/text-box';
import DxValidator, {
    DxRequiredRule,
    DxEmailRule
} from 'devextreme-vue/validator';
import DxValidationGroup from 'devextreme-vue/validation-group';
import DxValidationSummary from 'devextreme-vue/validation-summary';
import DxButton from 'devextreme-vue/button';

let email = undefined;
let password = undefined;

const validate = (params) => {
    let result = params.validationGroup.validate();
    if (result.isValid) {
        // the values are valid
        // submit and reset them
        // params.validationGroup.reset();
        console.log(result);
    }
}
</script>

Refer to the Data Validation article for more information.

Vue Form Input Bindings Support

DevExtreme editors support the v-model directive that creates two-way binding on the editor's value.

App.vue (Options API)
App.vue (Composition API)
<template>
    <DxTextBox v-model="bindingProperty" />
</template>

<script>
import DxTextBox from 'devextreme-vue/text-box';

export default {
    components: {
        DxTextBox
    },
    data() {
        return {
            bindingProperty: 'Some value'
        }
    }
}
</script>
<template>
    <DxTextBox v-model="bindingProperty" />
</template>

<script setup>
import DxTextBox from 'devextreme-vue/text-box';

let bindingProperty = 'Some value';
</script>
IMPORTANT
In Vue 2 applications, you can use the .sync modifier to implement two-way binding.

DevExtreme Angular - Component Configuration Syntax

Static String Property Value

HTML
<dx-button text="Simple button"></dx-button>

Static Non-String Property Value

HTML
<dx-button
    [disabled]="false"
    [width]="50">
</dx-button>

Properties of the Object Type

Use UI components prefixed with dxo- ("o" stands for "object"). In the following example, we configure the TreeMap's tooltip property:

HTML
<dx-tree-map>
    <dxo-tooltip
        [enabled]="true"
        format="thousands">
    </dxo-tooltip>
</dx-tree-map>

Particular properties of the object type are not implemented as nested components. These properties depend on the values of other properties and therefore cannot be typed (columns[].editorOptions in the DataGrid, item's editorOptions in the Form, items[].options in the Toolbar). Specify them with an object:

HTML
<dx-data-grid>
    <dxi-column
        [editorOptions]="{ width: 100 }">
    </dxi-column>
</dx-data-grid>

Collections

Use UI components prefixed with dxi- ("i" stands for "item"). The following example shows how to configure the DataGrid's columns property:

HTML
<dx-data-grid>
    <dxi-column dataField="firstName" caption="First Name"></dxi-column>
    <dxi-column dataField="lastName" caption="Last Name" [visible]="false"></dxi-column>
</dx-data-grid>

For properties that accept either an object or a collection, use UI components prefixed with dxi- as well. The series and valueAxis properties in the Chart UI component exemplify this case:

HTML
<dx-chart>
    <dxi-series valueField="value" argumentField="argument"></dxi-series>
    <dxi-value-axis>
        <dxo-label format="millions"></dxo-label>
    </dxi-value-axis>
</dx-chart>

A special dxi- element, dxi-item, is designed to declare items in collection UI components. It supports structural directives provided by Angular, for instance, ngFor. The following code shows how to use dxi-item to declare items in the List UI component.

dxi-item also supports directives that control parts of item appearance, such as badge in the code below. They are described in the items section of each collection UI component.

app.component.html
app.component.ts
<dx-list>
    <dxi-item>
        <h1>Available items</h1>
    </dxi-item>
    <dxi-item *ngFor="let item of listItems" [badge]="item.badge">
        <h2>{{item.text}}</h2>
    </dxi-item>
</dx-list>
// ...
export class AppComponent {
    listItems = [{
        text: 'Cars',
        badge: '12'
    }, {
        text: 'Bikes',
        badge: '5'
    }];
}

If a dxi-item contains nested components, wrap the content in an element with the dxTemplate directive without parameters:

HTML
<dx-list>
    <dxi-item>
        <div *dxTemplate>
            <dx-button text="I am a nested component"></dx-button>
        </div>
    </dxi-item>
</dx-list>

Event Handling

app.component.html
app.component.ts
<dx-button
    text="OK"
    (onClick)="okClicked($event)">
</dx-button>
import notify from "devextreme/ui/notify";
// ...
export class AppComponent {
    okClicked (e) {
        notify("The OK button was clicked")
    }
}

In nested components, the () syntax cannot be used. Use the [] syntax instead:

app.component.html
app.component.ts
<dx-data-grid>
    <dxi-column type="buttons">
        <dxi-button
            [onClick]="okClicked">
        </dxi-button>
    </dxi-column>
</dx-data-grid>
import notify from "devextreme/ui/notify";
// ...
export class AppComponent {
    okClicked (e) {
        notify("The OK button was clicked")
    }
}

Callback Functions

app.component.html
app.component.ts
<dx-vector-map>
    <dxi-layer
        [customize]="customizeLayers">
    </dxi-layer>
</dx-vector-map>
// ...
export class AppComponent {
    customizeLayers(elements) {
        // ...
    }
}

Callback functions are executed outside the component's context. If the context is important, explicitly bind the callback function to it in the constructor.

app.component.ts
app.component.html
// ...
export class AppComponent {
    myCountry: string = "USA"; // we need to access this context variable in the callback function

    constructor() {
        this.customizeLayers = this.customizeLayers.bind(this);
    }

    customizeLayers(elements) {
        let country = this.myCountry;
        // ...
    }
}
<dx-vector-map>
    <dxi-layer
        [customize]="customizeLayers">
    </dxi-layer>
</dx-vector-map>

One-Way Property Binding

Changes in the bindingProperty are propagated to the TextBox's value, but not vice versa:

app.component.html
app.component.ts
<dx-text-box [value]="bindingProperty"></dx-text-box>
// ...
export class AppComponent {
    bindingProperty: string = "Some value";
}

Two-Way Property Binding

Changes in the bindingProperty are propagated to the TextBox's value and vice versa:

app.component.html
app.component.ts
<dx-text-box [(value)]="bindingProperty"></dx-text-box>
// ...
export class AppComponent {
    bindingProperty: string = "Some value";
}

Declare Content in the Markup

The following UI components allow you to declare their content directly in the markup:

The following is an example with ScrollView:

app.component.html
<dx-scroll-view>
    <div>Some scrollable content</div>
</dx-scroll-view>
IMPORTANT

These UI components do not support dynamically or conditionally rendered content in their root element. For example, the following code does not work:

app.component.html
<dx-popup [(visible)]="showPopup">
    {{ popupContent }}
</dx-popup>

Wrap the content in a static element:

app.component.html
<dx-popup [(visible)]="showPopup">
    <div>
        {{ popupContent }}
    </div>
</dx-popup>

Templates

Templates allow you to customize UI component elements. In the following code, an itemTemplate called listItem and a groupTemplate called listGroup customize items and groups in the List. Inside the templates, the itemData and groupData variables expose item and group data objects; the itemIndex variable gives access to the item index.

HTML
<dx-list
    [items]="groupedItems"
    [grouped]="true"
    itemTemplate="listItem"
    groupTemplate="listGroup">
    <div *dxTemplate="let itemData of 'listItem'; let itemIndex = index">
        {{itemIndex}} - {{itemData.itemProperty}}
    </div>
    <div *dxTemplate="let groupData of 'listGroup'">
        {{groupData.groupProperty}}
    </div>
</dx-list>
NOTE
The dxTemplate attribute directive cannot be used on custom markup elements.

Refer to the common Custom Templates article for more information.

NOTE

Angular has a built-in template directive. This causes an error when you try to specify an eponymous property on a configuration component (for instance, on dxo-master-detail). In this case, use the following syntax:

HTML
<dxo-master-detail [template]="'masterDetail'"></dxo-master-detail>

External Templates

External templates are created using the ng-template element. The following code replicates the example above, but here the itemTemplate is the external template. The groupTemplate is omitted.

The ngTemplateOutlet directive uses a template reference variable to reference the external template. The ngTemplateOutletContext directive specifies variables that are accessible in the template.

custom-list.component.html
<dx-list [items]="items" itemTemplate="listItem">
    <div *dxTemplate="let itemData of 'listItem'; let itemIndex = index">
        <ng-template 
            [ngTemplateOutlet]="customItemTemplate" 
            [ngTemplateOutletContext]="{ itemData: itemData, itemIndex: itemIndex }">
        </ng-template>
    </div>
</dx-list>

<ng-template #customItemTemplate let-data="itemData" let-index="itemIndex">
    {{index}} - {{data.itemProperty}}
</ng-template>

In the previous code, the external template is used in the same component in which it is declared. The following code illustrates the case when the external template is declared in another component. The ngTemplateOutlet directive should be set to an input property in this case:

parent.component.html
custom-list.component.html
custom-list.component.ts
<ng-template #customItemTemplate let-data="itemData" let-index="itemIndex">
    {{index}} - {{data.itemProperty}}
</ng-template>

<custom-list
    [externalItemTemplate]="customItemTemplate"> 
</custom-list>
<dx-list ...
    itemTemplate="listItem">
    <div *dxTemplate="let itemData of 'listItem'; let itemIndex = index">
        <ng-template 
            [ngTemplateOutlet]="externalItemTemplate" 
            [ngTemplateOutletContext]="{ itemData: itemData, itemIndex: itemIndex }">
        </ng-template>
    </div>
</dx-list>
import { Component, Input, TemplateRef } from '@angular/core';
@Component({
    selector: 'custom-list',
    templateUrl: './custom-list.component.html'
})
export class CustomListComponent {
    @Input() externalItemTemplate: TemplateRef<any>
    // ...
}

Call Methods

To call UI component methods, you need its instance. To access it, use the @ViewChild or @ViewChildren decorator (depending on whether you are getting a single or multiple UI component instances) and the component's instance property. These decorators accept a component name or a template reference variable. The following code illustrates this approach by the example of the DataGrid:

app.component.ts
app.component.html
import { Component, ViewChild } from "@angular/core";
import { DxDataGridComponent } from "devextreme-angular";
// ...
export class AppComponent {
    @ViewChild(DxDataGridComponent, { static: false }) dataGrid: DxDataGridComponent
    // ===== or using a template reference variable =====
    @ViewChild("targetDataGrid", { static: false }) dataGrid: DxDataGridComponent

    // Prior to Angular 8
    // @ViewChild(DxDataGridComponent) dataGrid: DxDataGridComponent
    // @ViewChild("targetDataGrid") dataGrid: DxDataGridComponent
    refresh() {
        this.dataGrid.instance.refresh();
    }

    // Getting multiple instances of one UI component
    // @ViewChildren(DxDataGridComponent) dataGrids: QueryList<DxDataGridComponent>
}
<dx-data-grid #targetDataGrid [dataSource]="dataSource"></dx-data-grid>
<dx-button text="Refresh data" (onClick)="refresh()"></dx-button>

Alternatively, you can assign the UI component instance to a variable and use it to call the methods:

app.component.html
app.component.ts
<dx-data-grid
    [dataSource]="dataSource"
    (onInitialized)="saveGridInstance($event)">
</dx-data-grid>
<dx-button text="Refresh data" (onClick)="refresh()"></dx-button>
import { Component } from "@angular/core";
import DataGrid from "devextreme/ui/data_grid";
// ...
export class AppComponent {
    dataGridInstance: DataGrid;
    saveGridInstance (e) {
        this.dataGridInstance = e.component;
    }
    refresh() {
        this.dataGridInstance.refresh();
    }
}

Get a UI Component Instance

You can access a UI component instance in the component as described in Call Methods.

You can also use template reference variables to access a UI component instance in the markup:

HTML
<dx-select-box #targetSelectBox [items]="items"></dx-select-box>
{{targetSelectBox.value}}

Data Layer

DevExtreme Data Layer is a set of components for working with data. Refer to the Data Layer API reference for code examples.

DevExtreme Validation Features

In the following example, two textboxes are placed in a validation group that is validated on a button click. Each textbox has a set of validation rules. The validation result is displayed under the textboxes in a validation summary.

app.component.html
app.component.ts
app.module.ts
<dx-validation-group>
    <dx-text-box [(value)]="email">
        <dx-validator>
            <dxi-validation-rule type="required" message="Email is required"></dxi-validation-rule>
            <dxi-validation-rule type="email" message="Email is invalid"></dxi-validation-rule>
        </dx-validator>
    </dx-text-box>

    <dx-text-box [(value)]="password" mode="password">
        <dx-validator>
            <dxi-validation-rule type="required" message="Password is required"></dxi-validation-rule>
        </dx-validator>
    </dx-text-box>

    <dx-validation-summary></dx-validation-summary>

    <dx-button (onClick)="validate($event)" text="Submit"></dx-button>
</dx-validation-group>
// ...
export class AppComponent {
    email: string;
    password: string;
    validate(params) {
        let result = params.validationGroup.validate();
        if (result.isValid) {
            // the values are valid
            // submit and reset them
            // params.validationGroup.reset();
        }
    }
}
// ...
import {
    DxTextBoxModule,
    DxValidatorModule,
    DxValidationSummaryModule,
    DxValidationGroupModule,
    DxButtonModule
} from 'devextreme-angular';

@NgModule({
    // ...
    imports: [
        // ...
        DxTextBoxModule,
        DxValidatorModule,
        DxValidationSummaryModule,
        DxValidationGroupModule,
        DxButtonModule
    ]
})
export class AppModule { }

Refer to the Data Validation article for more information.

Angular Forms Support

DevExtreme editors support the formControlName directive needed for features of reactive forms...

app.component.html
app.component.ts
app.module.ts
<form [formGroup]="myForm">
    <dx-text-box
        name="email"
        formControlName="email"
        [isValid]="emailControl.valid || emailControl.pristine"
        [validationError]="{ message: 'Email is invalid'}">
    </dx-text-box>
</form>
import { Component, OnInit } from '@angular/core';
import { FormGroup, FormControl, AbstractControl, Validators } from '@angular/forms';
// ...
export class AppComponent implements OnInit {
    email: string;
    emailControl: AbstractControl;
    myForm: FormGroup;
    ngOnInit() {
        this.myForm = new FormGroup({
            email: new FormControl('', Validators.compose([Validators.required, Validators.email]))
        });
        this.emailControl = this.myForm.controls['email'];
    }
}
// ...
import { ReactiveFormsModule } from '@angular/forms';
import { DxTextBoxModule } from 'devextreme-angular';

@NgModule({
    // ...
    imports: [
        // ...
        DxTextBoxModule,
        ReactiveFormsModule
    ]
})
export class AppModule { }

... and ngModel binding necessary to use the editors in template-driven forms:

app.component.html
app.component.ts
app.module.ts
<form>
    <dx-text-box
        name="email"
        email required
        #emailControl="ngModel"
        [(ngModel)]="email"
        [isValid]="emailControl.valid || emailControl.pristine"
        [validationError]="{ message: 'Email is invalid'}">
    </dx-text-box>
</form>
// ...
export class AppComponent {
    email: string;
}
// ...
import { FormsModule } from '@angular/forms';
import { DxTextBoxModule } from 'devextreme-angular';

@NgModule({
    // ...
    imports: [
        // ...
        DxTextBoxModule,
        FormsModule
    ]
})
export class AppModule { }

Angular Change Detection Specifics

Angular activates change detection on each property change. This approach backfires when you try to pass functions to UI component properties that do not accept them. For example:

app.component.ts
import { Component } from '@angular/core';

enum GridColumnsOption {
    PersonalDetails = 0,
    JobDetails = 1,
}

@Component({
    selector: 'app-component',
    template: `
        <dx-data-grid
            [columns]="getColumns(columnsOption)">
        </dx-data-grid>
    `,
})

export class AppComponent {
    columnsOption = GridColumnsOption.PersonalDetails;

    getColumns(option: GridColumnsOption): string[] {
        switch (option) {
            case GridColumnsOption.PersonalDetails:
                return [
                    'name',
                    'address',
                    'phone',
                ];
            case GridColumnsOption.JobDetails:
                return [
                    'name',
                    'position',
                    'salary',
                ];
            default:
                return [];
        }
    }
}

In the code above, the getColumns() function returns an array of objects, but this array is created from scratch each time the function is called. This is what happens when you run this code:

  1. The getColumns() function returns an array.
  2. The array gets assigned to the columns property. This activates change detection.
  3. When comparing the old and new columns values, the change detection mechanism calls getColumns() again and receives a different array.
  4. The array gets assigned to the columns property, and the cycle repeats infinitely.

To work around this behavior, implement one of the following techniques:

Use a component’s class field instead of a method.

app.component.ts
import { Component } from '@angular/core';

enum GridColumnsOption {
    PersonalDetails = 0,
    JobDetails = 1,
}

@Component({
    selector: 'app-component',
    template: `
        <dx-data-grid
            [columns]="columns[columnsOption]">
        </dx-data-grid>
    `,
})

export class AppComponent {
    columnsOption = GridColumnsOption.PersonalDetails;

    columns = {
        [GridColumnsOption.PersonalDetails]: [
            'name',
            'address',
            'phone',
        ],
        [GridColumnsOption.JobDetails]: [
            'name',
            'position',
            'salary',
        ],
    };
}

Rewrite a component’s class method to a custom Angular pipe.

app.component.ts
import { 
    Component,
    Pipe,
    PipeTransform,
} from '@angular/core';

enum GridColumnsOption {
    PersonalDetails = 0,
    JobDetails = 1,
}

@Pipe({name: 'columnsPipe'})
export class ExponentialStrengthPipe implements PipeTransform {
    transform(columnsOption: GridColumnsOption): string[] {
        switch (option) {
            case GridColumnsOption.PersonalDetails:
                return [
                    'name',
                    'address',
                    'phone',
                ];
            case GridColumnsOption.JobDetails:
                return [
                    'name',
                    'position',
                    'salary',
                ];
            default:
                return [];
        }
    }
}

@Component({
    selector: 'app-component',
    template: `
        <dx-data-grid
            [columns]="columnsOption | columnsPipe">
        </dx-data-grid>
    `,
})
export class AppComponent {
    columnsOption = GridColumnsOption.PersonalDetails;
} 

Cache the return value of the component’s method (for example, you can use a universal apply pipe).

app.component.ts
    import { 
        Component,
        Pipe,
        PipeTransform, 
    } from '@angular/core';

    enum GridColumnsOption {
        PersonalDetails = 0,
        JobDetails = 1,
    }

    @Pipe({ name: 'apply' })
    export class ApplyPipe<TArgs, TReturn> implements PipeTransform {
        transform(func: ((...args: TArgs[]) => TReturn), ...args: TArgs[]): TReturn { return func(...args); }
    }

    @Component({
        selector: 'app-component',
        template: `
            <dx-data-grid
                [columns]="getColumns | apply: columnsOption">
            </dx-data-grid>
        `,
    })
    export class AppComponent {
        columnsOption = GridColumnsOption.PersonalDetails;

        getColumns = (option: GridColumnsOption): string[] => {
            switch (option) {
                case GridColumnsOption.PersonalDetails:
                    return [
                        'name',
                        'address',
                        'phone',
                    ];
                case GridColumnsOption.JobDetails:
                    return [
                        'firstName',
                        'position',
                        'salary',
                    ];
                default:
                    return [];
            }
        }
    }
NOTE
We recommend that you use an arrow function with this technique.